/// \file ServerDispatch.h
///
///  Virtual access to host filesystem via CP/Net-style I/O device.
///
///  \date Feb 19, 2016
///  \author Douglas Miller
///

#ifndef SERVERDISPATCH_H_
#define SERVERDISPATCH_H_

#include "NetworkServer.h"
#include "HostFileBdos.h"
#include "propertyutil.h"

#include <string>
#include <stdint.h>

class ServerDispatch {
public:
	ServerDispatch();
	virtual ~ServerDispatch();
	void install_ServerDispatch(PropertyUtil::PropertyMapT &props,
				std::string prefix, uint8_t cid, uint8_t &hid);

protected:
	void addServer(uint8_t serverId, NetworkServer *server);
	void swapIds(struct NetworkServer::ndos *header);
	int sendMsg(uint8_t *msgbuf, int len);
	int checkRecvMsg(uint8_t clientId, uint8_t *msgbuf, int len);
private:
	std::map<uint8_t, NetworkServer *> servers;
};

#endif	// SERVERDISPATCH_H_
